<template>
    <div>
        <h2>Réserver</h2>
        <div class="stage-1">
            <div class="stage-1-left">
                <div class="inputs">
                    <label for="nom_utilisateur">Nom</label>
                    <input type="text" name="nom_utilisateur" id="nom_utilisateur" v-model="nom_utilisateur" required>
                </div>

                <div class="inputs">
                    <label for="prenom_utilisateur">Prénom</label>
                    <input type="text" name="prenom_utilisateur" id="prenom_utilisateur" v-model="prenom_utilisateur" required>
                </div>

                <div class="inputs">
                    <label for="prenom_utilisateur">Téléphone</label>
                    <input type="text" name="telephone_utilisateur" id="telephone_utilisateur" v-model="telephone_utilisateur" required>
                </div>

            </div>

            <div class="stage-1-right">

                <div class="inputs">
                    <label for="rue_utilisateur">Rue</label>
                    <input type="text" name="rue_utilisateur" id="rue_utilisateur" v-model="rue_utilisateur" required>
                </div>

                <div class="services">
                    <p>Service</p>
                    <div>
                        <label for="service_baby_utilisateur"><img :src=biberon alt="" srcset=""></label>
                        <input type="radio" id="service_baby_utilisateur" name="service" value="Baby sitting" v-model="picked">

                        <label for="service_dog_utilisateur"><img :src=chien alt="" srcset=""></label>
                        <input type="radio" id="service_dog_utilisateur" name="service" value="Dog sitting" v-model="picked">
                    </div>

                </div>

                <div class="ville-selector">
                    <label for="ville_utilisateur">Ville</label>
                    <select name="ville" id="ville" v-model="ville_utilisateur">
                        <option value="Nantes">Nantes</option>
                        <option value="Tours">Tours</option>
                    </select>
                </div>

            </div>
        </div>

        <div class="stage-2">
            <div :class="{
                    'calendar-container' : this.picked != null,
                    'calendar-container-disable' : this.picked == null
                }">
                <div class="title-calendar">
                    <p class="title">Calendrier</p>
                    <img class="info-icon" src="../assets/img/info.svg" alt="" title="Pour réserver une horaire" @click="triggerPop()"> 
                </div>
                <Calendar :picked="picked" :setHeure="setHeure"/>
            </div>
            <div class="comment">
                <p class="title">Commentaire</p>
                <p>(Toutes informations nous est utile )</p>
                <textarea name="" id="" cols="30" rows="10" v-model="commentaire_utilisateur"></textarea>
            </div>
        </div>

        <div class="resume">
            <p class="title">Résumé</p>
            <div>
                <p>Une réservation au nom de {{nom_utilisateur}} {{prenom_utilisateur}}</p>
                <p>Contact au : {{telephone_utilisateur}}</p>
                <p>Pour domicile {{rue_utilisateur}} dans la ville de {{ville_utilisateur}}</p>
                <p>Pour du <span class="value_user">{{picked}}</span> le {{jour}} de <span class="value_user">{{heure_debut}}</span> à  <span class="value_user">{{heure_fin}}</span></p>
                <p class="comment-line">Commentaire : {{commentaire_utilisateur}}</p>
                <p>Total de : {{ total }} 💵</p>
            </div>
        </div>

        <div class="info-error">
            {{ error_message }}
        </div>

        <div class="send" @click="sendReservation()">
            Réserver
        </div>
        <PopUp :savoirPlus="service.text" v-if="showPopUp" v-bind:showPopUp="showPopUp" v-bind:triggerPop="triggerPop"/>
    </div>
</template>

<script>

import Biberon from "../assets/img/biberon.svg"
import Chien from "../assets/img/dog.svg"
import Calendar from "../components/Calendar.vue"
import PopUp from "../components/PopUp.vue"

import axios from "axios"

export default {
    name:"ReserverPage",
    components:{
        Calendar,
        PopUp
    },
    data(){
        return{
            showPopUp : false,
            biberon: Biberon,
            chien: Chien,
            nom_utilisateur: "",
            prenom_utilisateur: "",
            telephone_utilisateur: "",
            rue_utilisateur: "",
            ville_utilisateur: null,
            commentaire_utilisateur: "",
            picked: null,
            heure_debut: null,
            heure_fin: null,
            jour: null,
            amount:{
                baby:8.48,
                dog:10
            },
            service:{
                text: "Description calendrier"
            },
            error_message: ""
        }
    },
    methods:{
        setHeure(jour, start, end){
            this.jour = jour
            this.heure_debut = start
            this.heure_fin = end
        },
        fieldsIsEmpty(){

            const pattern = /^(06|07)[1-9][0-9]{7}$/gm

            if (this.nom_utilisateur.trim() == ""){
                return 1
            } else if (this.prenom_utilisateur.trim() == ""){
                return 2
            } else if (this.picked == null){
                return 3
            } else if (this.rue_utilisateur.trim() == ""){
                return 4
            } else if (this.ville_utilisateur == null){
                return 5
            } else if (this.telephone_utilisateur.trim() == "" || this.telephone_utilisateur.match(pattern) == null){
                return 6
            } else if (this.jour == null || this.heure_debut == null || this.heure_fin == null){
                return 7
            } else if (this.commentaire_utilisateur.trim() == ""){
                return 8
            } else if (this.total == 0){
                return 9
            }

            return 0
        },
        errorMessageManager(state){

            let message = ""

            switch(state){
                case 1:
                    message = "Votre nom d'utilisateur est incorrect."
                break
                case 2:
                    message = "Votre prénom est incorrect."
                break
                case 3:
                    message = "Il faut choisir un service."
                break
                case 4:
                    message = "Votre adresse est incorrect."
                break
                case 5:
                    message = "Vous n'avez pas choisi de ville"
                break
                case 6:
                    message = "Le numéro de téléphone est incorrect"
                break
                case 7:
                    message = "Vous n'avez pas sélectionner de date."
                break
                case 8:
                    message = "Un commentaire peut m'être utile."
                break
                case 9:
                    message = "Problème au niveau du prix."
                break
            }

            this.error_message = message
        },
        sendReservation(){

            const fields = this.fieldsIsEmpty()

            if (fields != 0){
                this.errorMessageManager(fields)
                return 0
            }

            const url = "http://localhost:5000/add/reservation"
            const data = {
                    nom : this.nom_utilisateur,
                    prenom: this.prenom_utilisateur,
                    telephone: this.telephone_utilisateur,
                    service: this.picked,
                    rue: this.rue_utilisateur,
                    ville : this.ville_utilisateur,
                    jour: this.jour,
                    heure_debut : this.heure_debut,
                    heure_fin : this.heure_fin,
                    commentaire : this.commentaire_utilisateur,
                    total : this.total
            }

            axios.post(url, data)
            .then((response) => {
                if (response.status == 200){
                    this.error = "Votre réservation, a bien été prise en compte 😉"
                    this.show = true
                    setTimeout(()=>this.$router.push('/'),2000)
                }
            })
            .catch((response) => console.log("errrrr"+response))
        },
        triggerPop(){
            this.showPopUp = !this.showPopUp
        }

    },
    computed:{
        total(){
            let debut = new Date(this.jour+"T"+this.heure_debut)
            let fin = new Date(this.jour+"T"+this.heure_fin)

            let result = ((fin.getTime() - debut.getTime()) / 1000) / 3600

            if (this.picked == "Baby sitting")
                return (result * this.amount.baby).toFixed(2)
            else if(this.picked == "Dog sitting")
                return (result * this.amount.dog).toFixed(2)
            else
                return 0
        }
    }
}
</script>

<style lang="scss" scoped>

@import "../style/default";

*{
font-family: $default_font;  
}

.title{
    
    text-align: start;
    font-size: 3em;
    font-weight: 500;
    margin-bottom:0;
    
}

.stage-1, .stage-2, .resume{
    width: 90%;
    margin-left: 5%;
    margin-top: 5%;
}

.stage-1{
    display: flex;

    gap: 5%;

    &-left, &-right{
        .inputs{

            display: flex;

            flex-direction: column;

            align-items: flex-start;

            text-align: start;

            margin-top: 5%;

            width: 100%;

            input[type="text"]{
                font-size: 2em;
                letter-spacing: 2px;
                width: 90%;
                outline: none;
                border:1px solid black;
                border-radius: 5px;
            }

            label{
                font-size: 2.3em;
                margin-bottom: 1%;
            }
        }
    }



    &-left{
        //border: 2px solid blue;
        width: 50%;
    }

    &-right{

        //border: 2px solid red;

        width: 50%;

        display: flex;

        align-items: flex-start;

        flex-direction: column;

        .services{

            margin-top: 3%;

            display: flex;

            width: 100%;

            gap: 15%;

            p{
                font-size: 2.3em;
                text-align: left;
            }
            img{
                width: 80px;
            }
        }

        .ville-selector{
            display: flex;
            align-items: flex-start;

            label{
                font-size: 2.3em;
            }

            select{
                font-size: 2em;
                margin-left: 5%;
            }

        }

    }
}

.stage-2{

    .calendar-container{

        &-disable{
            pointer-events: none;
            opacity: 0.5;
            background: #CCC;
        }

        transition: all .5s;
    }

    .title{
        margin-bottom: 5%;
    }

    .info-icon{
        width: 25px;
        margin-left: 2%;
        cursor: pointer;
    }

    .title-calendar{
        display: flex;
    }

    .comment{

        p:nth-child(2){
            text-align: start;
        }

        textarea{

            display: block;

            width: 90%;
            height: 300px;
            font-size: 2em;
            margin-left: 0%;

            resize: none;
            outline: none;

            letter-spacing: 5px;
        }
    }
}

.resume{
    border-left: 2px solid black;

    div, .title{
        margin-left: 3%;
    }

    div{
        
        text-align: start;

        p{
            font-size: 1.5em;
            font-weight: 400;
            margin-top: 2%;
        }
    }
}

.send{        

    display: flex;

    align-items: center;
    justify-content: center;

    cursor: pointer;
    border:2px solid $background_green;


    border-radius: 5px;

    background-color: $background_green;

    height: 50px;

    font-size: 2em;

    color:white;

    width: 20%;

    margin-left: 40%;
    margin-top: 5%;

    }

.comment-line{
    word-break: break-all;
}
</style>